diff -uNrd ircd-ratbox-1.3-1/modules/m_services.c BgChat-Ircd/modules/m_services.c
--- ircd-ratbox-1.3-1/modules/m_services.c	Wed Dec 31 19:00:00 1969
+++ BgChat-Ircd/modules/m_services.c	Mon Mar 29 07:17:53 2004
@@ -0,0 +1,403 @@
+/*
+ *  ircd-hybrid: an advanced Internet Relay Chat Daemon(ircd).
+ *  m_SERVJOIN.c: Joins a channel via admin or service CMD.
+ *
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
+ *  USA
+ *
+ *  $Id: m_services.c,v 1.1 2004/02/02 22:19:43 HaKer4o Exp $
+ */
+
+#include "stdinc.h"
+#include "tools.h"
+#include "handlers.h"
+#include "channel.h"
+#include "channel_mode.h"
+#include "client.h"
+#include "common.h"
+#include "resv.h"
+#include "hash.h"
+#include "irc_string.h"
+#include "ircd.h"
+#include "numeric.h"
+#include "send.h"
+#include "s_serv.h"
+#include "s_conf.h"
+#include "msg.h"
+#include "parse.h"
+#include "modules.h"
+#include "sprintf_irc.h"
+#include "packet.h"
+
+static void m_SERVJOIN(struct Client *, struct Client *, int, char **);
+
+struct Message SERVJOIN_msgtab = {
+	"SERVJOIN", 0, 0, 3, 0, MFLG_SLOW, 0,
+	{m_unregistered, m_SERVJOIN, m_SERVJOIN, m_SERVJOIN}
+};
+
+#ifndef STATIC_MODULES
+
+void
+_modinit(void)
+{
+	mod_add_cmd(&SERVJOIN_msgtab);
+}
+
+void
+_moddeinit(void)
+{
+	mod_del_cmd(&SERVJOIN_msgtab);
+}
+const char *_version = "$Revision: 1.4 2004/01/23 $";
+
+#endif
+static void do_join_0(struct Client *client_p, struct Client *source_p);
+void check_spambot_warning(struct Client *source_p, const char *name);
+
+
+/*
+ * m_SERVJOIN
+ *      parv[0] = sender prefix
+ *      parv[1] = destination nickname
+ *      parv[2] = channel(s) to join
+ *	parv[3] = password (key)
+ */
+static void
+m_SERVJOIN(struct Client *client_p, struct Client *source_p, int parc, char *parv[])
+{
+	static char jbuf[BUFSIZE];
+	struct Channel *chptr = NULL;
+	struct Client *dest_p = NULL;
+	struct ResvEntry *resv;
+	char *name, *key = NULL;
+	int i, flags = 0;
+	char *p = NULL, *p2 = NULL;
+	int successful_join_count = 0;	/* Number of channels successfully joined */
+
+	if (!IsServer(source_p) && !IsAdmin(source_p)) {
+		sendto_one(source_p, form_str(ERR_RESTRICTED), me.name, source_p->name);
+		return;
+	
+	}
+
+	if(EmptyString(parv[1]))
+	{
+		sendto_one(source_p, form_str(ERR_NEEDMOREPARAMS), me.name, parv[0], "SERVJOIN");
+		return;
+	}
+
+	if(EmptyString(parv[2]))
+	{
+		sendto_one(source_p, form_str(ERR_NEEDMOREPARAMS), me.name, parv[0], "SERVJOIN");
+		return;
+	}
+
+	if(!(dest_p = find_client(parv[1])))
+	{
+		sendto_one(source_p, form_str(ERR_NOSUCHNICK), me.name, parv[0], parv[1]);
+		return;
+
+	}
+
+	if(MyClient(dest_p))
+	{
+		
+
+		*jbuf = '\0';
+
+		/* rebuild the list of channels theyre supposed to be joining.
+		 * this code has a side effect of losing keys, but..
+		 */
+		for (i = 0, name = strtoken(&p, parv[2], ","); name;
+		     name = strtoken(&p, (char *) NULL, ","))
+		{
+			/* check the length and name of channel is ok */
+			if(!check_channel_name(name) || (strlen(name) > CHANNELLEN))
+			{
+				sendto_one(source_p, form_str(ERR_BADCHANNAME),
+					   me.name, source_p->name, (unsigned char *) name);
+				continue;
+			}
+
+			if(*name == '0' && !atoi(name))
+			{
+				(void) strcpy(jbuf, "0");
+				continue;
+			}
+
+			/* check it begins with # or & */
+			else if(!IsChannelName(name) ||
+				(ConfigServerHide.disable_local_channels && (*name == '&')))
+			{
+				sendto_one(source_p, form_str(ERR_NOSUCHCHANNEL),
+					   me.name, source_p->name, name);
+				continue;
+			}
+
+			/* see if its resv'd */
+			if(((resv = hash_find_resv(name)) != NULL)
+			   && (!IsOper(dest_p) || !ConfigChannel.no_oper_resvs))
+			{
+				sendto_one(source_p, form_str(ERR_BADCHANNAME),
+					   me.name, source_p->name, name);
+				
+				continue;
+			}
+
+			if(splitmode && !IsOper(dest_p) && (*name != '&') &&
+			   ConfigChannel.no_join_on_split)
+			{
+				sendto_one(source_p, form_str(ERR_UNAVAILRESOURCE),
+					   me.name, source_p->name, name);
+				continue;
+			}
+
+			if(*jbuf)
+				(void) strcat(jbuf, ",");
+			(void) strlcat(jbuf, name, sizeof(jbuf) - i - 1);
+			i += strlen(name) + 1;
+		}
+
+		if(parc > 3)
+		{
+			key = strtoken(&p2, parv[3], ",");
+		}
+
+		for (name = strtoken(&p, jbuf, ","); name;
+		     key = (key) ? strtoken(&p2, NULL, ",") : NULL, name = strtoken(&p, NULL, ","))
+		{
+			/* JOIN 0 simply parts all channels the user is in */
+			if(*name == '0' && !atoi(name))
+			{
+				if(!IsServer(source_p))
+				{
+					if(dest_p->user->channel.head == NULL)
+						continue;
+
+					do_join_0(&me, dest_p);
+				}
+				continue;
+			}
+
+			/* look for the channel */
+			if((chptr = hash_find_channel(name)) != NULL)
+			{
+				if(IsMember(dest_p, chptr))
+					continue;
+
+				if(dlink_list_length(&chptr->members) == 0)
+					flags = CHFL_CHANOP;
+				else
+					flags = 0;
+			}
+			else
+			{
+				if(splitmode && !IsOper(dest_p) && (*name != '&') &&
+				   ConfigChannel.no_create_on_split)
+				{
+					sendto_one(source_p, form_str(ERR_UNAVAILRESOURCE),
+						   me.name, source_p->name, name);
+					continue;
+				}
+
+				flags = CHFL_CHANOP;
+			}
+
+			if((dlink_list_length(&dest_p->user->channel) >=
+			    ConfigChannel.max_chans_per_user) && (!IsOper(dest_p)
+								  ||
+								  (dlink_list_length
+								   (&dest_p->user->channel) >=
+								   ConfigChannel.
+								   max_chans_per_user * 3)))
+			{
+				sendto_one(source_p, form_str(ERR_TOOMANYCHANNELS), me.name,
+					   parv[0], name);
+				if(successful_join_count)
+					dest_p->localClient->last_join_time = CurrentTime;
+				return;
+			}
+
+			if(flags == 0)	/* if channel doesn't exist, don't penalize */
+				successful_join_count++;
+
+			if(chptr == NULL)	/* If I already have a chptr, no point doing this */
+			{
+				chptr = get_or_create_channel(dest_p, name, NULL);
+
+				if(chptr == NULL)
+				{
+					sendto_one(source_p, form_str(ERR_UNAVAILRESOURCE), me.name,
+						   parv[0], name);
+					if(successful_join_count > 0)
+						successful_join_count--;
+					continue;
+				}
+			}
+
+
+			if(!IsOper(dest_p) && !IsExemptSpambot(dest_p))
+				check_spambot_warning(dest_p, name);
+
+			/* can_join checks for +i key, bans etc */
+			if((i = can_join(dest_p, chptr, key)))
+			{
+				sendto_one(source_p, form_str(i), me.name, parv[1], name);
+				if(successful_join_count > 0)
+					successful_join_count--;
+				continue;
+			}
+
+			/* add the user to the channel */
+			add_user_to_channel(chptr, dest_p, flags);
+
+			/* we send the user their join here, because we could have to
+			 * send a mode out next.
+			 */
+			sendto_channel_local(ALL_MEMBERS, chptr, ":%s!%s@%s JOIN :%s",
+					     dest_p->name,
+					     dest_p->username, dest_p->host, chptr->chname);
+
+			/* if theyre joining opped (ie, new chan or joining one thats
+			 * persisting) then set timestamp to current, set +nt and
+			 * broadcast the sjoin with its old modes, or +nt.
+			 */
+			if(flags & CHFL_CHANOP)
+			{
+				char mbuf[MODEBUFLEN];
+				char pbuf[MODEBUFLEN];
+
+				chptr->channelts = CurrentTime;
+				chptr->mode.mode |= MODE_TOPICLIMIT;
+				chptr->mode.mode |= MODE_NOPRIVMSGS;
+
+				sendto_channel_local(ALL_MEMBERS, chptr, ":%s MODE %s +nt",
+						     me.name, chptr->chname);
+
+				if(*chptr->chname == '#')
+				{
+					channel_modes(chptr, dest_p, mbuf, pbuf);
+
+					strlcat(mbuf, " ", sizeof(mbuf));
+
+					if(pbuf[0] != '\0')
+						strlcat(mbuf, pbuf, sizeof(mbuf));
+
+					/* note: mbuf here will have a trailing space.  we add one above,
+					 * and channel_modes() will leave a trailing space on pbuf if
+					 * its used --fl
+					 */
+					sendto_server(&me/*client_p*/, chptr, NOCAPS, NOCAPS,
+						      ":%s SJOIN %lu %s %s:@%s",
+						      me.name, (unsigned long) chptr->channelts,
+						      chptr->chname, mbuf, parv[1]);
+				}
+
+				/* drop our +beI modes */
+				free_channel_list(&chptr->banlist);
+				free_channel_list(&chptr->exceptlist);
+				free_channel_list(&chptr->invexlist);
+
+				/* REMOVE THIS AND DIE --fl */
+				chptr->num_mask = 0;
+			}
+			else
+			{
+				sendto_server(&me/*client_p*/, chptr, NOCAPS, NOCAPS,
+					      ":%s SJOIN %lu %s + :%s",
+					      me.name, (unsigned long) chptr->channelts,
+					      chptr->chname, parv[1]);
+			}
+
+			del_invite(chptr, dest_p);
+
+			if(chptr->topic != NULL)
+			{
+				sendto_one(dest_p, form_str(RPL_TOPIC), me.name,
+					   parv[1], chptr->chname, chptr->topic);
+
+				if(!(chptr->mode.mode & MODE_HIDEOPS) || (flags & CHFL_CHANOP))
+				{
+					sendto_one(dest_p, form_str(RPL_TOPICWHOTIME),
+						   me.name, parv[1], chptr->chname,
+						   chptr->topic_info, chptr->topic_time);
+				}
+				else	/* Hide from nonops */
+				{
+					sendto_one(dest_p, form_str(RPL_TOPICWHOTIME),
+						   me.name, parv[1], chptr->chname,
+						   me.name, chptr->topic_time);
+				}
+			}
+
+			channel_member_names(chptr, dest_p, 1);
+
+			if(successful_join_count)
+				source_p->localClient->last_join_time = CurrentTime;
+		}
+	}
+	else
+	{
+		sendto_realops_flags(UMODE_ALL, L_ADMIN,
+				     "Remote SERVJOIN from %s for %s/%s. Okay, forwarding message...",
+				     parv[0], parv[1], parv[2]);
+
+		if(parc >= 4)
+			sendto_one(dest_p->servptr, ":%s SERVJOIN %s %s %s", me.name,
+				   parv[1], parv[2], parv[3]);
+		else
+			sendto_one(dest_p->servptr, ":%s SERVJOIN %s %s", me.name, parv[1], parv[2]);
+	}
+}
+
+/*
+ * do_join_0
+ *
+ * inputs	- pointer to client doing join 0
+ * output	- NONE
+ * side effects	- Use has decided to join 0. This is legacy
+ *		  from the days when channels were numbers not names. *sigh*
+ *		  There is a bunch of evilness necessary here due to
+ * 		  anti spambot code.
+ */
+
+static void
+do_join_0(struct Client *client_p, struct Client *source_p)
+{
+	struct Channel *chptr = NULL;
+	struct membership *msptr;
+	dlink_node *lp;
+
+	/* Finish the flood grace period... */
+	if(MyClient(source_p) && !IsFloodDone(source_p))
+		flood_endgrace(source_p);
+
+
+	sendto_server(client_p, NULL, NOCAPS, NOCAPS, ":%s JOIN 0", source_p->name);
+
+	if(source_p->user->channel.head && MyConnect(source_p) &&
+	   !IsOper(source_p) && !IsExemptSpambot(source_p))
+		check_spambot_warning(source_p, NULL);
+
+	while ((lp = source_p->user->channel.head))
+	{
+		msptr = lp->data;
+		chptr = msptr->chptr;
+		sendto_channel_local(ALL_MEMBERS, chptr, ":%s!%s@%s PART %s",
+				     source_p->name,
+				     source_p->username, source_p->host, chptr->chname);
+		remove_user_from_channel(msptr);
+	}
+}
diff -uNrd ircd-ratbox-1.3-1/modules/m_servnick.c BgChat-Ircd/modules/m_servnick.c
--- ircd-ratbox-1.3-1/modules/m_servnick.c	Wed Dec 31 19:00:00 1969
+++ BgChat-Ircd/modules/m_servnick.c	Fri Apr  9 05:27:48 2004
@@ -0,0 +1,193 @@
+/*
+ *  ircd-hybrid: an advanced Internet Relay Chat Daemon(ircd).
+ *  m_servnick.c: Sets a users nick to random one when the nickname is
+ *               registered and user did not identify within 30 seconds.
+ *  BgChat Devel [HaKer4o]
+ *  $Id: m_servnick.c,v 1.109 2004/02/10 14:46:00 HaKer4o Exp $
+ */
+
+#include "stdinc.h"
+#include "handlers.h"
+#include "client.h"
+#include "hash.h"
+#include "fdlist.h"
+#include "irc_string.h"
+#include "ircd.h"
+#include "numeric.h"
+#include "s_conf.h"
+#include "s_stats.h"
+#include "s_user.h"
+#include "hash.h"
+#include "whowas.h"
+#include "s_serv.h"
+#include "send.h"
+#include "channel.h"
+#include "s_log.h"
+#include "resv.h"
+#include "msg.h"
+#include "parse.h"
+#include "modules.h"
+#include "common.h"
+#include "packet.h"
+
+
+static void m_servnick(struct Client *, struct Client *, int, char **);
+
+static int check_clean_nick(struct Client *, struct Client *, char *, char *, char *);
+static int clean_nick_name(char *);
+
+struct Message servnick_msgtab = {
+	"SERVNICK", 0, 0, 3, 0, MFLG_SLOW, 0,
+	{m_ignore, m_servnick, m_servnick, m_servnick}
+};
+
+#ifndef STATIC_MODULES
+void
+_modinit(void)
+{
+	mod_add_cmd(&servnick_msgtab);
+}
+
+void
+_moddeinit(void)
+{
+	mod_del_cmd(&servnick_msgtab);
+}
+
+const char *_version = "$Revision: 1.1 $";
+#endif
+
+/*
+ * m_servnick()
+ *
+ *     parv[0] = sender prefix
+ *     parv[1] = target nickname
+ *     parv[2] = new nickname
+ */
+static void
+m_servnick(struct Client *client_p, struct Client *source_p, int parc, char *parv[])
+{
+	char nick[NICKLEN];
+	struct Client *target_p;
+	struct Client *dest_p;
+
+	if (!IsServer(source_p) && !IsAdmin(source_p)) {
+	    return;
+	}
+	
+	if(parc < 3 || BadPtr(parv[2]))
+	{
+  	  sendto_wallops_flags(UMODE_WALLOP, &me,
+	     "No nickname given via servnick from %s for %s", parv[0], parv[1]);
+		return;
+	}
+
+	/* terminate nick to NICKLEN */
+	strlcpy(nick, parv[2], sizeof(nick));
+
+	/* check the nickname is ok */
+	if(!clean_nick_name(nick))
+	{
+  	  sendto_wallops_flags(UMODE_WALLOP, &me,
+	     "Bogus nickname via servnick from %s for %s : %s", parv[0], parv[1], parv[2]);
+      return;
+	}
+
+	if(find_nick_resv(nick))
+	{
+  	  sendto_wallops_flags(UMODE_WALLOP, &me,
+	     "Unavailable nickname via servnick from %s for %s : %s", parv[0], parv[1], parv[2]);
+		return;
+	}
+	
+	if(!(dest_p = find_client(parv[1]))) {
+  	  sendto_wallops_flags(UMODE_WALLOP, &me,
+	     "Nickname (%s) not found via SERVNICK",parv[1]);
+		return;
+	}
+	if (MyClient(dest_p)) {
+    	    ilog(L_ALL,"SERVNICK LOCAL %s %s",parv[1],parv[2]);	
+  	  sendto_wallops_flags(UMODE_WALLOP, &me,
+	     "SERVNICK [ %s ] -> [ %s ] by %s",parv[1],parv[2],parv[0]);
+
+	    change_local_nick(&me, dest_p, nick);
+	    }
+	else {
+    	    ilog(L_ALL,"SERVNICK REMOTE %s %s",parv[1],parv[2]);	
+  	  sendto_wallops_flags(UMODE_WALLOP, &me,
+	     "SERVNICK [ %s ] -> [ %s ] by %s",parv[1],parv[2],parv[0]);
+	    sendto_one(dest_p->servptr,":%s SERVNICK %s %s", me.name,
+	                                      parv[1], nick);
+	}
+}
+/* 
+ * check_clean_nick()
+ * 
+ * input	- pointer to source
+ *		- nickname
+ *		- truncated nickname
+ *		- origin of client
+ * output	- none
+ * side effects - if nickname is erroneous, or a different length to
+ *                truncated nickname, return 1
+ */
+static int
+check_clean_nick(struct Client *client_p, struct Client *source_p,
+		 char *nick, char *newnick, char *server)
+{
+	/* the old code did some wacky stuff here, if the nick is invalid, kill it
+	 * and dont bother messing at all
+	 */
+
+	/*
+	 * Zero length nicks are bad too..this shouldn't happen but..
+	 */
+
+	if(!clean_nick_name(nick) || strcmp(nick, newnick) || nick[0] == '\0')
+	{
+		ServerStats->is_kill++;
+		sendto_realops_flags(UMODE_DEBUG, L_ALL,
+				     "Bad Nick: %s From: %s(via %s)", nick, server, client_p->name);
+
+		sendto_one(client_p, ":%s KILL %s :%s (Bad Nickname)", me.name, newnick, me.name);
+
+		/* bad nick change */
+		if(source_p != client_p)
+		{
+			kill_client_serv_butone(client_p, source_p, "%s (Bad Nickname)", me.name);
+			source_p->flags |= FLAGS_KILLED;
+			exit_client(client_p, source_p, &me, "Bad Nickname");
+		}
+
+		return 1;
+	}
+
+	return 0;
+}
+
+/* clean_nick_name()
+ *
+ * input	- nickname
+ * output	- none
+ * side effects - walks through the nickname, returning 0 if erroneous
+ */
+static int
+clean_nick_name(char *nick)
+{
+	assert(nick);
+	if(nick == NULL)
+		return 0;
+
+	/* nicks cant start with a digit or -, and must have a length */
+	if(*nick == '-' || IsDigit(*nick) || !*nick)
+		return 0;
+
+	for (; *nick; nick++)
+	{
+		if(!IsNickChar(*nick))
+			return 0;
+	}
+
+	return 1;
+}
+
diff -uNrd ircd-ratbox-1.3-1/modules/m_svshint.c BgChat-Ircd/modules/m_svshint.c
--- ircd-ratbox-1.3-1/modules/m_svshint.c	Wed Dec 31 19:00:00 1969
+++ BgChat-Ircd/modules/m_svshint.c	Fri Apr  9 05:16:17 2004
@@ -0,0 +1,141 @@
+/************************************************************************
+ *   IRC - Internet Relay Chat, modules/m_version.c
+ *   Copyright (C) 1990 Jarkko Oikarinen and
+ *                      University of Oulu, Computing Center
+ *  Tenks for Stx Fix NoKick List :-) 
+ *   BgChat Devel [Haker4o]
+ *   $Id: m_svshint.c,v 1.3 2004/03/01 03:16:20 stx/haker4o Exp $
+ */
+#include "stdinc.h"
+#include "handlers.h"
+#include "client.h"
+#include "common.h"		/* TRUE bleah */
+#include "irc_string.h"
+#include "ircd.h"
+#include "hash.h"
+#include "numeric.h"
+#include "send.h"
+#include "s_conf.h"
+#include "s_log.h"
+#include "s_serv.h"
+#include "msg.h"
+#include "parse.h"
+#include "modules.h"
+
+
+static void ms_svshint(struct Client *, struct Client *, int, char **);
+struct Message svshint_msgtab = {
+	"SVSHINT", 0, 1, 0, 0, 0, 0,
+	{m_unregistered, m_ignore, ms_svshint, m_ignore}
+};
+
+#ifndef STATIC_MODULES
+void
+_modinit(void)
+{
+	mod_add_cmd(&svshint_msgtab);
+}
+
+void
+_moddeinit(void)
+{
+	mod_del_cmd(&svshint_msgtab);
+}
+
+char *_version = "20031228_1";
+#endif
+/*
+ * ms_svshint - SVSHINT command handler
+ *      parv[0] = sender prefix
+ *      parv[1] = hint flags
+ *      parv[2] = nick
+ */
+static void
+ms_svshint(struct Client *client_p, struct Client *source_p, int parc, char *parv[])
+{
+	struct Client *victim;
+	unsigned int hint;
+
+	if(parc < 4)
+		return;
+
+	victim = find_client(parv[2]);
+
+	if(!IsServer(source_p))
+		return;
+
+	if(!(victim))
+		return;
+
+	if(!strcasecmp(parv[1], "NSID"))
+	{
+
+		if(!strcasecmp(parv[3], "1"))
+		{
+			SetNSId(victim);
+			CurrentIdentUsers++;
+
+			if(CurrentIdentUsers > MaxIdentUsers)
+				MaxIdentUsers = CurrentIdentUsers;
+
+		}
+		else
+		{
+			ClearNSId(victim);
+			CurrentIdentUsers--;
+
+			if(CurrentIdentUsers < 0)
+				CurrentIdentUsers = 0;
+		}
+
+		sendto_server(client_p, NULL, NOCAPS, NOCAPS,
+			      ":%s SVSHINT NSID %s %s", me.name, victim->name, parv[3]);
+		return;
+	}
+
+	if(!strcasecmp(parv[1], "OSID") && !IsOSId(victim))
+	{
+		SetOSId(victim);
+		CurrentOSidUsers++;
+
+		if(CurrentOSidUsers > MaxOSidUsers)
+			MaxOSidUsers = CurrentOSidUsers;
+
+		sendto_server(client_p, NULL, NOCAPS, NOCAPS,
+			      ":%s SVSHINT OSID %s 1", me.name, victim->name);
+		return;
+	}
+
+	// Add nokick chan for user - stx
+	if(!strcasecmp(parv[1], "NOKICK") && (parc == 5))
+	{
+		if(strcmp(parv[4], "1") == 0)
+			add_nokick_chan(victim, parv[3]);
+
+		else
+			del_nokick_chan(victim, parv[3]);
+
+		sendto_server(client_p, NULL, NOCAPS, NOCAPS,
+			      ":%s SVSHINT NOKICK %s %s %s", me.name, victim->name, parv[3],
+			      parv[4]);
+		return;
+	}
+
+	// Gliner identified - stx-haker4o
+	if(!strcasecmp(parv[1], "NK"))
+	{
+		ilog(L_ALL, "Adding GLiner ID for %s", victim->name);
+		SetGLId(victim);
+
+		CurrentGlinerUsers++;
+
+		if(CurrentGlinerUsers > MaxGlinerUsers)
+			MaxGlinerUsers = CurrentGlinerUsers;
+
+		sendto_server(client_p, NULL, NOCAPS, NOCAPS,
+			      ":%s SVSHINT NK %s 1", me.name, victim->name);
+		return;
+	}
+
+
+}
diff -uNrd ircd-ratbox-1.3-1/modules/m_svsjoin.c BgChat-Ircd/modules/m_svsjoin.c
--- ircd-ratbox-1.3-1/modules/m_svsjoin.c	Wed Dec 31 19:00:00 1969
+++ BgChat-Ircd/modules/m_svsjoin.c	Mon Mar 29 07:17:53 2004
@@ -0,0 +1,417 @@
+/*
+ *  ircd-hybrid: an advanced Internet Relay Chat Daemon(ircd).
+ *  m_svsjoin.c: Joins a channel via admin or service CMD.
+ *
+ *  Copyright (C) 1990 Jarkko Oikarinen and University of Oulu, Co Center
+ *  Copyright (C) 1996-2002 Hybrid Development Team
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
+ *  USA
+ *
+ *  $Id: m_svsjoin.c,v 1.3 2004/02/02 22:19:43 HaKer4o Exp $
+ */
+
+#include "stdinc.h"
+#include "tools.h"
+#include "handlers.h"
+#include "channel.h"
+#include "channel_mode.h"
+#include "client.h"
+#include "common.h"
+#include "resv.h"
+#include "hash.h"
+#include "irc_string.h"
+#include "ircd.h"
+#include "numeric.h"
+#include "send.h"
+#include "s_serv.h"
+#include "s_conf.h"
+#include "msg.h"
+#include "parse.h"
+#include "modules.h"
+#include "sprintf_irc.h"
+#include "packet.h"
+
+static void m_svsjoin(struct Client *, struct Client *, int, char **);
+
+struct Message svsjoin_msgtab = {
+	"SVSJOIN", 0, 0, 3, 0, MFLG_SLOW, 0,
+	{m_unregistered, m_svsjoin, m_svsjoin, m_svsjoin}
+};
+
+#ifndef STATIC_MODULES
+
+void
+_modinit(void)
+{
+	mod_add_cmd(&svsjoin_msgtab);
+}
+
+void
+_moddeinit(void)
+{
+	mod_del_cmd(&svsjoin_msgtab);
+}
+const char *_version = "$Revision: 1.4 2004/01/23 $";
+
+#endif
+static void do_join_0(struct Client *client_p, struct Client *source_p);
+void check_spambot_warning(struct Client *source_p, const char *name);
+
+
+/*
+ * m_svsjoin
+ *      parv[0] = sender prefix
+ *      parv[1] = destination nickname
+ *      parv[2] = channel(s) to join
+ *	parv[3] = password (key)
+ */
+static void
+m_svsjoin(struct Client *client_p, struct Client *source_p, int parc, char *parv[])
+{
+	static char jbuf[BUFSIZE];
+	struct Channel *chptr = NULL;
+	struct Client *dest_p = NULL;
+	struct ResvEntry *resv;
+	char *name, *key = NULL;
+	int i, flags = 0;
+	char *p = NULL, *p2 = NULL;
+	int successful_join_count = 0;	/* Number of channels successfully joined */
+
+	if (!IsServer(source_p) && !IsAdmin(source_p)) {
+		sendto_one(source_p, form_str(ERR_RESTRICTED), me.name, source_p->name);
+		return;
+	
+	}
+
+	if(EmptyString(parv[1]))
+	{
+		sendto_one(source_p, form_str(ERR_NEEDMOREPARAMS), me.name, parv[0], "SVSJOIN");
+		return;
+	}
+
+	if(EmptyString(parv[2]))
+	{
+		sendto_one(source_p, form_str(ERR_NEEDMOREPARAMS), me.name, parv[0], "SVSJOIN");
+		return;
+	}
+
+	if(!(dest_p = find_client(parv[1])))
+	{
+		sendto_one(source_p, form_str(ERR_NOSUCHNICK), me.name, parv[0], parv[1]);
+		return;
+
+	}
+
+	if(MyClient(dest_p))
+	{
+		sendto_realops_flags(UMODE_ALL, L_ADMIN, "Local SVSJOIN from %s for %s/%s", parv[0],
+				     parv[1], parv[2]);
+
+		*jbuf = '\0';
+
+		/* rebuild the list of channels theyre supposed to be joining.
+		 * this code has a side effect of losing keys, but..
+		 */
+		for (i = 0, name = strtoken(&p, parv[2], ","); name;
+		     name = strtoken(&p, (char *) NULL, ","))
+		{
+			/* check the length and name of channel is ok */
+			if(!check_channel_name(name) || (strlen(name) > CHANNELLEN))
+			{
+				sendto_one(source_p, form_str(ERR_BADCHANNAME),
+					   me.name, source_p->name, (unsigned char *) name);
+				continue;
+			}
+
+			if(*name == '0' && !atoi(name))
+			{
+				(void) strcpy(jbuf, "0");
+				continue;
+			}
+
+			/* check it begins with # or & */
+			else if(!IsChannelName(name) ||
+				(ConfigServerHide.disable_local_channels && (*name == '&')))
+			{
+				sendto_one(source_p, form_str(ERR_NOSUCHCHANNEL),
+					   me.name, source_p->name, name);
+				continue;
+			}
+
+			/* see if its resv'd */
+			if(((resv = hash_find_resv(name)) != NULL)
+			   && (!IsOper(dest_p) || !ConfigChannel.no_oper_resvs))
+			{
+				sendto_one(source_p, form_str(ERR_BADCHANNAME),
+					   me.name, source_p->name, name);
+				sendto_realops_flags(UMODE_SPY, L_ALL,
+						     "User %s (%s@%s) was forced to join locally juped channel %s (%s)",
+						     dest_p->name, dest_p->username, dest_p->host,
+						     name, resv->reason);
+				continue;
+			}
+
+			if(splitmode && !IsOper(dest_p) && (*name != '&') &&
+			   ConfigChannel.no_join_on_split)
+			{
+				sendto_one(source_p, form_str(ERR_UNAVAILRESOURCE),
+					   me.name, source_p->name, name);
+				continue;
+			}
+
+			if(*jbuf)
+				(void) strcat(jbuf, ",");
+			(void) strlcat(jbuf, name, sizeof(jbuf) - i - 1);
+			i += strlen(name) + 1;
+		}
+
+		if(parc > 3)
+		{
+			key = strtoken(&p2, parv[3], ",");
+		}
+
+		for (name = strtoken(&p, jbuf, ","); name;
+		     key = (key) ? strtoken(&p2, NULL, ",") : NULL, name = strtoken(&p, NULL, ","))
+		{
+			/* JOIN 0 simply parts all channels the user is in */
+			if(*name == '0' && !atoi(name))
+			{
+				if(!IsServer(source_p))
+				{
+					if(dest_p->user->channel.head == NULL)
+						continue;
+
+					do_join_0(&me, dest_p);
+				}
+				else
+				{
+					sendto_wallops_flags(UMODE_WALLOP, &me,
+							     "SVSJOIN from %s for %s on channel %s REJECTED!",
+							     parv[0], parv[1], parv[2]);
+				}
+				continue;
+			}
+
+			/* look for the channel */
+			if((chptr = hash_find_channel(name)) != NULL)
+			{
+				if(IsMember(dest_p, chptr))
+					continue;
+
+				if(dlink_list_length(&chptr->members) == 0)
+					flags = CHFL_CHANOP;
+				else
+					flags = 0;
+			}
+			else
+			{
+				if(splitmode && !IsOper(dest_p) && (*name != '&') &&
+				   ConfigChannel.no_create_on_split)
+				{
+					sendto_one(source_p, form_str(ERR_UNAVAILRESOURCE),
+						   me.name, source_p->name, name);
+					continue;
+				}
+
+				flags = CHFL_CHANOP;
+			}
+
+			if((dlink_list_length(&dest_p->user->channel) >=
+			    ConfigChannel.max_chans_per_user) && (!IsOper(dest_p)
+								  ||
+								  (dlink_list_length
+								   (&dest_p->user->channel) >=
+								   ConfigChannel.
+								   max_chans_per_user * 3)))
+			{
+				sendto_one(source_p, form_str(ERR_TOOMANYCHANNELS), me.name,
+					   parv[0], name);
+				if(successful_join_count)
+					dest_p->localClient->last_join_time = CurrentTime;
+				return;
+			}
+
+			if(flags == 0)	/* if channel doesn't exist, don't penalize */
+				successful_join_count++;
+
+			if(chptr == NULL)	/* If I already have a chptr, no point doing this */
+			{
+				chptr = get_or_create_channel(dest_p, name, NULL);
+
+				if(chptr == NULL)
+				{
+					sendto_one(source_p, form_str(ERR_UNAVAILRESOURCE), me.name,
+						   parv[0], name);
+					if(successful_join_count > 0)
+						successful_join_count--;
+					continue;
+				}
+			}
+
+
+			if(!IsOper(dest_p) && !IsExemptSpambot(dest_p))
+				check_spambot_warning(dest_p, name);
+
+			/* can_join checks for +i key, bans etc */
+			if((i = can_join(dest_p, chptr, key)))
+			{
+				sendto_one(source_p, form_str(i), me.name, parv[1], name);
+				if(successful_join_count > 0)
+					successful_join_count--;
+				continue;
+			}
+
+			/* add the user to the channel */
+			add_user_to_channel(chptr, dest_p, flags);
+
+			/* we send the user their join here, because we could have to
+			 * send a mode out next.
+			 */
+			sendto_channel_local(ALL_MEMBERS, chptr, ":%s!%s@%s JOIN :%s",
+					     dest_p->name,
+					     dest_p->username, dest_p->host, chptr->chname);
+
+			/* if theyre joining opped (ie, new chan or joining one thats
+			 * persisting) then set timestamp to current, set +nt and
+			 * broadcast the sjoin with its old modes, or +nt.
+			 */
+			if(flags & CHFL_CHANOP)
+			{
+				char mbuf[MODEBUFLEN];
+				char pbuf[MODEBUFLEN];
+
+				chptr->channelts = CurrentTime;
+				chptr->mode.mode |= MODE_TOPICLIMIT;
+				chptr->mode.mode |= MODE_NOPRIVMSGS;
+
+				sendto_channel_local(ALL_MEMBERS, chptr, ":%s MODE %s +nt",
+						     me.name, chptr->chname);
+
+				if(*chptr->chname == '#')
+				{
+					channel_modes(chptr, dest_p, mbuf, pbuf);
+
+					strlcat(mbuf, " ", sizeof(mbuf));
+
+					if(pbuf[0] != '\0')
+						strlcat(mbuf, pbuf, sizeof(mbuf));
+
+					/* note: mbuf here will have a trailing space.  we add one above,
+					 * and channel_modes() will leave a trailing space on pbuf if
+					 * its used --fl
+					 */
+					sendto_server(&me/*client_p*/, chptr, NOCAPS, NOCAPS,
+						      ":%s SJOIN %lu %s %s:@%s",
+						      me.name, (unsigned long) chptr->channelts,
+						      chptr->chname, mbuf, parv[1]);
+				}
+
+				/* drop our +beI modes */
+				free_channel_list(&chptr->banlist);
+				free_channel_list(&chptr->exceptlist);
+				free_channel_list(&chptr->invexlist);
+
+				/* REMOVE THIS AND DIE --fl */
+				chptr->num_mask = 0;
+			}
+			else
+			{
+				sendto_server(&me/*client_p*/, chptr, NOCAPS, NOCAPS,
+					      ":%s SJOIN %lu %s + :%s",
+					      me.name, (unsigned long) chptr->channelts,
+					      chptr->chname, parv[1]);
+			}
+
+			del_invite(chptr, dest_p);
+
+			if(chptr->topic != NULL)
+			{
+				sendto_one(dest_p, form_str(RPL_TOPIC), me.name,
+					   parv[1], chptr->chname, chptr->topic);
+
+				if(!(chptr->mode.mode & MODE_HIDEOPS) || (flags & CHFL_CHANOP))
+				{
+					sendto_one(dest_p, form_str(RPL_TOPICWHOTIME),
+						   me.name, parv[1], chptr->chname,
+						   chptr->topic_info, chptr->topic_time);
+				}
+				else	/* Hide from nonops */
+				{
+					sendto_one(dest_p, form_str(RPL_TOPICWHOTIME),
+						   me.name, parv[1], chptr->chname,
+						   me.name, chptr->topic_time);
+				}
+			}
+
+			channel_member_names(chptr, dest_p, 1);
+
+			if(successful_join_count)
+				source_p->localClient->last_join_time = CurrentTime;
+		}
+	}
+	else
+	{
+		sendto_realops_flags(UMODE_ALL, L_ADMIN,
+				     "Remote SVSJOIN from %s for %s/%s. Okay, forwarding message...",
+				     parv[0], parv[1], parv[2]);
+
+		if(parc >= 4)
+			sendto_one(dest_p->servptr, ":%s SVSJOIN %s %s %s", me.name,
+				   parv[1], parv[2], parv[3]);
+		else
+			sendto_one(dest_p->servptr, ":%s SVSJOIN %s %s", me.name, parv[1], parv[2]);
+	}
+}
+
+/*
+ * do_join_0
+ *
+ * inputs	- pointer to client doing join 0
+ * output	- NONE
+ * side effects	- Use has decided to join 0. This is legacy
+ *		  from the days when channels were numbers not names. *sigh*
+ *		  There is a bunch of evilness necessary here due to
+ * 		  anti spambot code.
+ */
+
+static void
+do_join_0(struct Client *client_p, struct Client *source_p)
+{
+	struct Channel *chptr = NULL;
+	struct membership *msptr;
+	dlink_node *lp;
+
+	/* Finish the flood grace period... */
+	if(MyClient(source_p) && !IsFloodDone(source_p))
+		flood_endgrace(source_p);
+
+
+	sendto_server(client_p, NULL, NOCAPS, NOCAPS, ":%s JOIN 0", source_p->name);
+
+	if(source_p->user->channel.head && MyConnect(source_p) &&
+	   !IsOper(source_p) && !IsExemptSpambot(source_p))
+		check_spambot_warning(source_p, NULL);
+
+	while ((lp = source_p->user->channel.head))
+	{
+		msptr = lp->data;
+		chptr = msptr->chptr;
+		sendto_channel_local(ALL_MEMBERS, chptr, ":%s!%s@%s PART %s",
+				     source_p->name,
+				     source_p->username, source_p->host, chptr->chname);
+		remove_user_from_channel(msptr);
+	}
+}
